/* imable.c generated by valac 0.11.6, the Vala compiler
 * generated from imable.vala, do not modify */

/*
 * Copyright (C) 2010 Collabora Ltd.
 *
 * This library is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation, either version 2.1 of the License, or
 * (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with this library.  If not, see <http://www.gnu.org/licenses/>.
 *
 * Authors:
 *       Philip Withnall <philip.withnall@collabora.co.uk>
 */

#include <glib.h>
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <gee.h>
#include <glib/gi18n-lib.h>


#define FOLKS_TYPE_IMABLE (folks_imable_get_type ())
#define FOLKS_IMABLE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), FOLKS_TYPE_IMABLE, FolksIMable))
#define FOLKS_IS_IMABLE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), FOLKS_TYPE_IMABLE))
#define FOLKS_IMABLE_GET_INTERFACE(obj) (G_TYPE_INSTANCE_GET_INTERFACE ((obj), FOLKS_TYPE_IMABLE, FolksIMableIface))

typedef struct _FolksIMable FolksIMable;
typedef struct _FolksIMableIface FolksIMableIface;

#define FOLKS_TYPE_LINKED_HASH_SET (folks_linked_hash_set_get_type ())
#define FOLKS_LINKED_HASH_SET(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), FOLKS_TYPE_LINKED_HASH_SET, FolksLinkedHashSet))
#define FOLKS_LINKED_HASH_SET_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), FOLKS_TYPE_LINKED_HASH_SET, FolksLinkedHashSetClass))
#define FOLKS_IS_LINKED_HASH_SET(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), FOLKS_TYPE_LINKED_HASH_SET))
#define FOLKS_IS_LINKED_HASH_SET_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), FOLKS_TYPE_LINKED_HASH_SET))
#define FOLKS_LINKED_HASH_SET_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), FOLKS_TYPE_LINKED_HASH_SET, FolksLinkedHashSetClass))

typedef struct _FolksLinkedHashSet FolksLinkedHashSet;
typedef struct _FolksLinkedHashSetClass FolksLinkedHashSetClass;
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_regex_unref0(var) ((var == NULL) ? NULL : (var = (g_regex_unref (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))

/**
 * Errors related to IM addresses and IM address handling.
 */
typedef enum  {
	FOLKS_IMABLE_ERROR_INVALID_IM_ADDRESS
} FolksIMableError;
#define FOLKS_IMABLE_ERROR folks_imable_error_quark ()
struct _FolksIMableIface {
	GTypeInterface parent_iface;
	GHashTable* (*get_im_addresses) (FolksIMable* self);
	void (*set_im_addresses) (FolksIMable* self, GHashTable* value);
};



GQuark folks_imable_error_quark (void);
GType folks_linked_hash_set_get_type (void) G_GNUC_CONST;
GType folks_imable_get_type (void) G_GNUC_CONST;
gchar* folks_imable_normalise_im_address (const gchar* im_address, const gchar* protocol, GError** error);
GHashTable* folks_imable_get_im_addresses (FolksIMable* self);
void folks_imable_set_im_addresses (FolksIMable* self, GHashTable* value);
static void _vala_array_destroy (gpointer array, gint array_length, GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array, gint array_length, GDestroyNotify destroy_func);
static gint _vala_array_length (gpointer array);


GQuark folks_imable_error_quark (void) {
	return g_quark_from_static_string ("folks_imable_error-quark");
}


/**
   * Normalise an IM address so that it's suitable for string comparison.
   *
   * IM addresses for various protocols can be represented in different ways,
   * only one of which is canonical. In order to allow simple string comparisons
   * of IM addresses to work, the IM addresses must be normalised beforehand.
   *
   * If the provided IM address is invalid,
   * {@link Folks.IMableError.INVALID_IM_ADDRESS} will be thrown. Note that this
   * isn't guaranteed to be thrown for all invalid addresses, but if it is
   * thrown, the address is guaranteed to be invalid.
   *
   * @param im_address the address to normalise
   * @param protocol the protocol of this im_address
   *
   * @since 0.2.0
   * @throws Folks.IMableError if the provided IM address was invalid
   */
static gchar* string_replace (const gchar* self, const gchar* old, const gchar* replacement) {
	gchar* result = NULL;
	gchar* _tmp0_ = NULL;
	gchar* _tmp1_;
	GRegex* _tmp2_ = NULL;
	GRegex* _tmp3_;
	GRegex* regex;
	gchar* _tmp4_ = NULL;
	gchar* _tmp5_;
	GError * _inner_error_ = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	g_return_val_if_fail (old != NULL, NULL);
	g_return_val_if_fail (replacement != NULL, NULL);
	_tmp0_ = g_regex_escape_string (old, -1);
	_tmp1_ = _tmp0_;
	_tmp2_ = g_regex_new (_tmp1_, 0, 0, &_inner_error_);
	regex = (_tmp3_ = _tmp2_, _g_free0 (_tmp1_), _tmp3_);
	if (_inner_error_ != NULL) {
		if (_inner_error_->domain == G_REGEX_ERROR) {
			goto __catch7_g_regex_error;
		}
		g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
		return NULL;
	}
	_tmp4_ = g_regex_replace_literal (regex, self, (gssize) (-1), 0, replacement, 0, &_inner_error_);
	_tmp5_ = _tmp4_;
	if (_inner_error_ != NULL) {
		_g_regex_unref0 (regex);
		if (_inner_error_->domain == G_REGEX_ERROR) {
			goto __catch7_g_regex_error;
		}
		_g_regex_unref0 (regex);
		g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
		return NULL;
	}
	result = _tmp5_;
	_g_regex_unref0 (regex);
	return result;
	_g_regex_unref0 (regex);
	goto __finally7;
	__catch7_g_regex_error:
	{
		GError * e;
		e = _inner_error_;
		_inner_error_ = NULL;
		g_assert_not_reached ();
		_g_error_free0 (e);
	}
	__finally7:
	if (_inner_error_ != NULL) {
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
		return NULL;
	}
}


gchar* folks_imable_normalise_im_address (const gchar* im_address, const gchar* protocol, GError** error) {
	gchar* result = NULL;
	gchar* normalised = NULL;
	gboolean _tmp0_ = FALSE;
	gchar* _tmp50_ = NULL;
	GError * _inner_error_ = NULL;
	g_return_val_if_fail (im_address != NULL, NULL);
	g_return_val_if_fail (protocol != NULL, NULL);
	if (g_strcmp0 (protocol, "aim") == 0) {
		_tmp0_ = TRUE;
	} else {
		_tmp0_ = g_strcmp0 (protocol, "myspace") == 0;
	}
	if (_tmp0_) {
		gchar* _tmp1_ = NULL;
		gchar* _tmp2_;
		gchar* _tmp3_ = NULL;
		gchar* _tmp4_;
		_tmp1_ = string_replace (im_address, " ", "");
		_tmp2_ = _tmp1_;
		_tmp3_ = g_utf8_strdown (_tmp2_, (gssize) (-1));
		_tmp4_ = _tmp3_;
		_g_free0 (normalised);
		normalised = _tmp4_;
		_g_free0 (_tmp2_);
	} else {
		gboolean _tmp5_ = FALSE;
		gboolean _tmp6_ = FALSE;
		gboolean _tmp7_ = FALSE;
		if (g_strcmp0 (protocol, "irc") == 0) {
			_tmp7_ = TRUE;
		} else {
			_tmp7_ = g_strcmp0 (protocol, "yahoo") == 0;
		}
		if (_tmp7_) {
			_tmp6_ = TRUE;
		} else {
			_tmp6_ = g_strcmp0 (protocol, "yahoojp") == 0;
		}
		if (_tmp6_) {
			_tmp5_ = TRUE;
		} else {
			_tmp5_ = g_strcmp0 (protocol, "groupwise") == 0;
		}
		if (_tmp5_) {
			gchar* _tmp8_ = NULL;
			gchar* _tmp9_;
			_tmp8_ = g_utf8_strdown (im_address, (gssize) (-1));
			_tmp9_ = _tmp8_;
			_g_free0 (normalised);
			normalised = _tmp9_;
		} else {
			if (g_strcmp0 (protocol, "jabber") == 0) {
				gchar** _tmp10_;
				gchar** _tmp11_ = NULL;
				gchar** parts;
				gint parts_length1;
				gint _parts_size_;
				gchar* resource;
				gchar** _tmp16_;
				gchar** _tmp17_ = NULL;
				gchar** _tmp18_;
				gchar* node = NULL;
				gchar* domain = NULL;
				gboolean _tmp28_ = FALSE;
				gboolean _tmp29_ = FALSE;
				gboolean _tmp30_ = FALSE;
				gchar* _tmp35_ = NULL;
				gchar* _tmp36_;
				gboolean _tmp39_ = FALSE;
				_tmp11_ = _tmp10_ = g_strsplit (im_address, "/", 2);
				parts = _tmp11_;
				parts_length1 = _vala_array_length (_tmp10_);
				_parts_size_ = _vala_array_length (_tmp10_);
				if (parts_length1 < 1) {
					const gchar* _tmp12_ = NULL;
					GError* _tmp13_ = NULL;
					_tmp12_ = _ ("The IM address '%s' could not be understood.");
					_tmp13_ = g_error_new (FOLKS_IMABLE_ERROR, FOLKS_IMABLE_ERROR_INVALID_IM_ADDRESS, _tmp12_, im_address);
					_inner_error_ = _tmp13_;
					if (_inner_error_->domain == FOLKS_IMABLE_ERROR) {
						g_propagate_error (error, _inner_error_);
						parts = (_vala_array_free (parts, parts_length1, (GDestroyNotify) g_free), NULL);
						_g_free0 (normalised);
						return NULL;
					} else {
						parts = (_vala_array_free (parts, parts_length1, (GDestroyNotify) g_free), NULL);
						_g_free0 (normalised);
						g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
						g_clear_error (&_inner_error_);
						return NULL;
					}
				}
				resource = NULL;
				if (parts_length1 == 2) {
					gchar* _tmp14_;
					gchar* _tmp15_;
					_tmp14_ = g_strdup (parts[1]);
					_tmp15_ = _tmp14_;
					_g_free0 (resource);
					resource = _tmp15_;
				}
				_tmp17_ = _tmp16_ = g_strsplit (parts[0], "@", 2);
				_tmp18_ = _tmp17_;
				parts = (_vala_array_free (parts, parts_length1, (GDestroyNotify) g_free), NULL);
				parts_length1 = _vala_array_length (_tmp16_);
				_parts_size_ = parts_length1;
				parts = _tmp18_;
				if (parts_length1 < 1) {
					const gchar* _tmp19_ = NULL;
					GError* _tmp20_ = NULL;
					_tmp19_ = _ ("The IM address '%s' could not be understood.");
					_tmp20_ = g_error_new (FOLKS_IMABLE_ERROR, FOLKS_IMABLE_ERROR_INVALID_IM_ADDRESS, _tmp19_, im_address);
					_inner_error_ = _tmp20_;
					if (_inner_error_->domain == FOLKS_IMABLE_ERROR) {
						g_propagate_error (error, _inner_error_);
						_g_free0 (resource);
						parts = (_vala_array_free (parts, parts_length1, (GDestroyNotify) g_free), NULL);
						_g_free0 (normalised);
						return NULL;
					} else {
						_g_free0 (resource);
						parts = (_vala_array_free (parts, parts_length1, (GDestroyNotify) g_free), NULL);
						_g_free0 (normalised);
						g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
						g_clear_error (&_inner_error_);
						return NULL;
					}
				}
				if (parts_length1 == 2) {
					gchar* _tmp21_;
					gchar* _tmp22_;
					gchar* _tmp23_;
					gchar* _tmp24_;
					_tmp21_ = g_strdup (parts[0]);
					_tmp22_ = _tmp21_;
					_g_free0 (node);
					node = _tmp22_;
					_tmp23_ = g_strdup (parts[1]);
					_tmp24_ = _tmp23_;
					_g_free0 (domain);
					domain = _tmp24_;
				} else {
					gchar* _tmp25_;
					gchar* _tmp26_;
					gchar* _tmp27_;
					_tmp25_ = NULL;
					_g_free0 (node);
					node = _tmp25_;
					_tmp26_ = g_strdup (parts[0]);
					_tmp27_ = _tmp26_;
					_g_free0 (domain);
					domain = _tmp27_;
				}
				if (node != NULL) {
					_tmp30_ = g_strcmp0 (node, "") == 0;
				} else {
					_tmp30_ = FALSE;
				}
				if (_tmp30_) {
					_tmp29_ = TRUE;
				} else {
					gboolean _tmp31_ = FALSE;
					if (domain == NULL) {
						_tmp31_ = TRUE;
					} else {
						_tmp31_ = g_strcmp0 (domain, "") == 0;
					}
					_tmp29_ = _tmp31_;
				}
				if (_tmp29_) {
					_tmp28_ = TRUE;
				} else {
					gboolean _tmp32_ = FALSE;
					if (resource != NULL) {
						_tmp32_ = g_strcmp0 (resource, "") == 0;
					} else {
						_tmp32_ = FALSE;
					}
					_tmp28_ = _tmp32_;
				}
				if (_tmp28_) {
					const gchar* _tmp33_ = NULL;
					GError* _tmp34_ = NULL;
					_tmp33_ = _ ("The IM address '%s' could not be understood.");
					_tmp34_ = g_error_new (FOLKS_IMABLE_ERROR, FOLKS_IMABLE_ERROR_INVALID_IM_ADDRESS, _tmp33_, im_address);
					_inner_error_ = _tmp34_;
					if (_inner_error_->domain == FOLKS_IMABLE_ERROR) {
						g_propagate_error (error, _inner_error_);
						_g_free0 (domain);
						_g_free0 (node);
						_g_free0 (resource);
						parts = (_vala_array_free (parts, parts_length1, (GDestroyNotify) g_free), NULL);
						_g_free0 (normalised);
						return NULL;
					} else {
						_g_free0 (domain);
						_g_free0 (node);
						_g_free0 (resource);
						parts = (_vala_array_free (parts, parts_length1, (GDestroyNotify) g_free), NULL);
						_g_free0 (normalised);
						g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
						g_clear_error (&_inner_error_);
						return NULL;
					}
				}
				_tmp35_ = g_utf8_strdown (domain, (gssize) (-1));
				_tmp36_ = _tmp35_;
				_g_free0 (domain);
				domain = _tmp36_;
				if (node != NULL) {
					gchar* _tmp37_ = NULL;
					gchar* _tmp38_;
					_tmp37_ = g_utf8_strdown (node, (gssize) (-1));
					_tmp38_ = _tmp37_;
					_g_free0 (node);
					node = _tmp38_;
				}
				if (node != NULL) {
					_tmp39_ = resource != NULL;
				} else {
					_tmp39_ = FALSE;
				}
				if (_tmp39_) {
					gchar* _tmp40_ = NULL;
					gchar* _tmp41_;
					_tmp40_ = g_strdup_printf ("%s@%s/%s", node, domain, resource);
					_tmp41_ = _tmp40_;
					_g_free0 (normalised);
					normalised = _tmp41_;
				} else {
					if (node != NULL) {
						gchar* _tmp42_ = NULL;
						gchar* _tmp43_;
						_tmp42_ = g_strdup_printf ("%s@%s", node, domain);
						_tmp43_ = _tmp42_;
						_g_free0 (normalised);
						normalised = _tmp43_;
					} else {
						if (resource != NULL) {
							gchar* _tmp44_ = NULL;
							gchar* _tmp45_;
							_tmp44_ = g_strdup_printf ("%s/%s", domain, resource);
							_tmp45_ = _tmp44_;
							_g_free0 (normalised);
							normalised = _tmp45_;
						} else {
							const gchar* _tmp46_ = NULL;
							GError* _tmp47_ = NULL;
							_tmp46_ = _ ("The IM address '%s' could not be understood.");
							_tmp47_ = g_error_new (FOLKS_IMABLE_ERROR, FOLKS_IMABLE_ERROR_INVALID_IM_ADDRESS, _tmp46_, im_address);
							_inner_error_ = _tmp47_;
							if (_inner_error_->domain == FOLKS_IMABLE_ERROR) {
								g_propagate_error (error, _inner_error_);
								_g_free0 (domain);
								_g_free0 (node);
								_g_free0 (resource);
								parts = (_vala_array_free (parts, parts_length1, (GDestroyNotify) g_free), NULL);
								_g_free0 (normalised);
								return NULL;
							} else {
								_g_free0 (domain);
								_g_free0 (node);
								_g_free0 (resource);
								parts = (_vala_array_free (parts, parts_length1, (GDestroyNotify) g_free), NULL);
								_g_free0 (normalised);
								g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
								g_clear_error (&_inner_error_);
								return NULL;
							}
						}
					}
				}
				_g_free0 (domain);
				_g_free0 (node);
				_g_free0 (resource);
				parts = (_vala_array_free (parts, parts_length1, (GDestroyNotify) g_free), NULL);
			} else {
				gchar* _tmp48_;
				gchar* _tmp49_;
				_tmp48_ = g_strdup (im_address);
				_tmp49_ = _tmp48_;
				_g_free0 (normalised);
				normalised = _tmp49_;
			}
		}
	}
	_tmp50_ = g_utf8_normalize (normalised, (gssize) (-1), G_NORMALIZE_DEFAULT);
	result = _tmp50_;
	_g_free0 (normalised);
	return result;
}


GHashTable* folks_imable_get_im_addresses (FolksIMable* self) {
	return FOLKS_IMABLE_GET_INTERFACE (self)->get_im_addresses (self);
}


void folks_imable_set_im_addresses (FolksIMable* self, GHashTable* value) {
	FOLKS_IMABLE_GET_INTERFACE (self)->set_im_addresses (self, value);
}


static void folks_imable_base_init (FolksIMableIface * iface) {
	static gboolean initialized = FALSE;
	if (!initialized) {
		initialized = TRUE;
		/**
		   * A mapping of IM protocol to an ordered set of IM addresses.
		   *
		   * Each mapping is from an arbitrary protocol identifier to a set of IM
		   * addresses on that protocol for the contact, listed in preference order.
		   * The most-preferred IM address for each protocol comes first in that
		   * protocol's list.
		   *
		   * There must be no duplicate IM addresses in each ordered set, though a given
		   * IM address may be present in the sets for different protocols.
		   *
		   * All the IM addresses must be normalised using
		   * {@link IMable.normalise_im_address} before being added to this property.
		   *
		   * @since 0.3.4
		   */
		g_object_interface_install_property (iface, g_param_spec_boxed ("im-addresses", "im-addresses", "im-addresses", G_TYPE_HASH_TABLE, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
	}
}


/**
 * IM addresses exposed by an object implementing {@link PresenceOwner}.
 *
 * @since 0.1.13
 */
GType folks_imable_get_type (void) {
	static volatile gsize folks_imable_type_id__volatile = 0;
	if (g_once_init_enter (&folks_imable_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (FolksIMableIface), (GBaseInitFunc) folks_imable_base_init, (GBaseFinalizeFunc) NULL, (GClassInitFunc) NULL, (GClassFinalizeFunc) NULL, NULL, 0, 0, (GInstanceInitFunc) NULL, NULL };
		GType folks_imable_type_id;
		folks_imable_type_id = g_type_register_static (G_TYPE_INTERFACE, "FolksIMable", &g_define_type_info, 0);
		g_type_interface_add_prerequisite (folks_imable_type_id, G_TYPE_OBJECT);
		g_once_init_leave (&folks_imable_type_id__volatile, folks_imable_type_id);
	}
	return folks_imable_type_id__volatile;
}


static void _vala_array_destroy (gpointer array, gint array_length, GDestroyNotify destroy_func) {
	if ((array != NULL) && (destroy_func != NULL)) {
		int i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}


static void _vala_array_free (gpointer array, gint array_length, GDestroyNotify destroy_func) {
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}


static gint _vala_array_length (gpointer array) {
	int length;
	length = 0;
	if (array) {
		while (((gpointer*) array)[length]) {
			length++;
		}
	}
	return length;
}



