/* presence-owner.c generated by valac 0.11.6, the Vala compiler
 * generated from presence-owner.vala, do not modify */

/*
 * Copyright (C) 2010-2011 Collabora Ltd.
 *
 * This library is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation, either version 2.1 of the License, or
 * (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with this library.  If not, see <http://www.gnu.org/licenses/>.
 *
 * Authors:
 *       Travis Reitter <travis.reitter@collabora.co.uk>
 */

#include <glib.h>
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>


#define FOLKS_TYPE_PRESENCE_TYPE (folks_presence_type_get_type ())

#define FOLKS_TYPE_PRESENCE_OWNER (folks_presence_owner_get_type ())
#define FOLKS_PRESENCE_OWNER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), FOLKS_TYPE_PRESENCE_OWNER, FolksPresenceOwner))
#define FOLKS_IS_PRESENCE_OWNER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), FOLKS_TYPE_PRESENCE_OWNER))
#define FOLKS_PRESENCE_OWNER_GET_INTERFACE(obj) (G_TYPE_INSTANCE_GET_INTERFACE ((obj), FOLKS_TYPE_PRESENCE_OWNER, FolksPresenceOwnerIface))

typedef struct _FolksPresenceOwner FolksPresenceOwner;
typedef struct _FolksPresenceOwnerIface FolksPresenceOwnerIface;

typedef enum  {
	FOLKS_PRESENCE_TYPE_UNSET,
	FOLKS_PRESENCE_TYPE_OFFLINE,
	FOLKS_PRESENCE_TYPE_AVAILABLE,
	FOLKS_PRESENCE_TYPE_AWAY,
	FOLKS_PRESENCE_TYPE_EXTENDED_AWAY,
	FOLKS_PRESENCE_TYPE_HIDDEN,
	FOLKS_PRESENCE_TYPE_BUSY,
	FOLKS_PRESENCE_TYPE_UNKNOWN,
	FOLKS_PRESENCE_TYPE_ERROR
} FolksPresenceType;

struct _FolksPresenceOwnerIface {
	GTypeInterface parent_iface;
	FolksPresenceType (*get_presence_type) (FolksPresenceOwner* self);
	void (*set_presence_type) (FolksPresenceOwner* self, FolksPresenceType value);
	const gchar* (*get_presence_message) (FolksPresenceOwner* self);
	void (*set_presence_message) (FolksPresenceOwner* self, const gchar* value);
};



GType folks_presence_type_get_type (void) G_GNUC_CONST;
GType folks_presence_owner_get_type (void) G_GNUC_CONST;
static gint _folks_presence_owner_type_availability (FolksPresenceType type);
gint folks_presence_owner_typecmp (FolksPresenceType type_a, FolksPresenceType type_b);
gboolean folks_presence_owner_is_online (FolksPresenceOwner* self);
FolksPresenceType folks_presence_owner_get_presence_type (FolksPresenceOwner* self);
void folks_presence_owner_set_presence_type (FolksPresenceOwner* self, FolksPresenceType value);
const gchar* folks_presence_owner_get_presence_message (FolksPresenceOwner* self);
void folks_presence_owner_set_presence_message (FolksPresenceOwner* self, const gchar* value);


/**
 * The possible presence states an object implementing {@link PresenceOwner}
 * could be in.
 *
 * These closely follow the
 * [[http://telepathy.freedesktop.org/spec/Connection_Interface_Simple_Presence.html#Connection_Presence_Type|SimplePresence]]
 * interface in the Telepathy specification.
 */
GType folks_presence_type_get_type (void) {
	static volatile gsize folks_presence_type_type_id__volatile = 0;
	if (g_once_init_enter (&folks_presence_type_type_id__volatile)) {
		static const GEnumValue values[] = {{FOLKS_PRESENCE_TYPE_UNSET, "FOLKS_PRESENCE_TYPE_UNSET", "unset"}, {FOLKS_PRESENCE_TYPE_OFFLINE, "FOLKS_PRESENCE_TYPE_OFFLINE", "offline"}, {FOLKS_PRESENCE_TYPE_AVAILABLE, "FOLKS_PRESENCE_TYPE_AVAILABLE", "available"}, {FOLKS_PRESENCE_TYPE_AWAY, "FOLKS_PRESENCE_TYPE_AWAY", "away"}, {FOLKS_PRESENCE_TYPE_EXTENDED_AWAY, "FOLKS_PRESENCE_TYPE_EXTENDED_AWAY", "extended-away"}, {FOLKS_PRESENCE_TYPE_HIDDEN, "FOLKS_PRESENCE_TYPE_HIDDEN", "hidden"}, {FOLKS_PRESENCE_TYPE_BUSY, "FOLKS_PRESENCE_TYPE_BUSY", "busy"}, {FOLKS_PRESENCE_TYPE_UNKNOWN, "FOLKS_PRESENCE_TYPE_UNKNOWN", "unknown"}, {FOLKS_PRESENCE_TYPE_ERROR, "FOLKS_PRESENCE_TYPE_ERROR", "error"}, {0, NULL, NULL}};
		GType folks_presence_type_type_id;
		folks_presence_type_type_id = g_enum_register_static ("FolksPresenceType", values);
		g_once_init_leave (&folks_presence_type_type_id__volatile, folks_presence_type_type_id);
	}
	return folks_presence_type_type_id__volatile;
}


static gint _folks_presence_owner_type_availability (FolksPresenceType type) {
	gint result = 0;
	switch (type) {
		case FOLKS_PRESENCE_TYPE_UNSET:
		{
			result = 0;
			return result;
		}
		case FOLKS_PRESENCE_TYPE_UNKNOWN:
		{
			result = 1;
			return result;
		}
		case FOLKS_PRESENCE_TYPE_ERROR:
		{
			result = 2;
			return result;
		}
		case FOLKS_PRESENCE_TYPE_OFFLINE:
		{
			result = 3;
			return result;
		}
		case FOLKS_PRESENCE_TYPE_HIDDEN:
		{
			result = 4;
			return result;
		}
		case FOLKS_PRESENCE_TYPE_EXTENDED_AWAY:
		{
			result = 5;
			return result;
		}
		case FOLKS_PRESENCE_TYPE_AWAY:
		{
			result = 6;
			return result;
		}
		case FOLKS_PRESENCE_TYPE_BUSY:
		{
			result = 7;
			return result;
		}
		case FOLKS_PRESENCE_TYPE_AVAILABLE:
		{
			result = 8;
			return result;
		}
		default:
		{
			result = 1;
			return result;
		}
	}
}


/**
   * Compare two {@link PresenceType}s.
   *
   * `0` will be returned if the types are equal, a positive number will be
   * returned if `type_a` is more available than `type_b`, and a negative
   * number will be returned if the opposite is true.
   *
   * @param type_a the first {@link PresenceType} to compare
   * @param type_b the second {@link PresenceType} to compare
   * @return a number representing the similarity of the two types
   * @since 0.1.11
   */
gint folks_presence_owner_typecmp (FolksPresenceType type_a, FolksPresenceType type_b) {
	gint result = 0;
	gint _tmp0_;
	gint _tmp1_;
	_tmp0_ = _folks_presence_owner_type_availability (type_a);
	_tmp1_ = _folks_presence_owner_type_availability (type_b);
	result = _tmp0_ - _tmp1_;
	return result;
}


/**
   * Whether the contact is online.
   *
   * This will be `true` if the contact's presence type is higher than
   * {@link PresenceType.OFFLINE}, as determined by
   * {@link PresenceOwner.typecmp}.
   *
   * @return `true` if the contact is online, `false` otherwise
   */
gboolean folks_presence_owner_is_online (FolksPresenceOwner* self) {
	gboolean result = FALSE;
	FolksPresenceType _tmp0_;
	gint _tmp1_;
	_tmp0_ = folks_presence_owner_get_presence_type (self);
	_tmp1_ = folks_presence_owner_typecmp (_tmp0_, FOLKS_PRESENCE_TYPE_OFFLINE);
	result = _tmp1_ > 0;
	return result;
}


FolksPresenceType folks_presence_owner_get_presence_type (FolksPresenceOwner* self) {
	return FOLKS_PRESENCE_OWNER_GET_INTERFACE (self)->get_presence_type (self);
}


void folks_presence_owner_set_presence_type (FolksPresenceOwner* self, FolksPresenceType value) {
	FOLKS_PRESENCE_OWNER_GET_INTERFACE (self)->set_presence_type (self, value);
}


const gchar* folks_presence_owner_get_presence_message (FolksPresenceOwner* self) {
	return FOLKS_PRESENCE_OWNER_GET_INTERFACE (self)->get_presence_message (self);
}


void folks_presence_owner_set_presence_message (FolksPresenceOwner* self, const gchar* value) {
	FOLKS_PRESENCE_OWNER_GET_INTERFACE (self)->set_presence_message (self, value);
}


static void folks_presence_owner_base_init (FolksPresenceOwnerIface * iface) {
	static gboolean initialized = FALSE;
	if (!initialized) {
		initialized = TRUE;
		/**
		   * The contact's presence type.
		   *
		   * Each contact can have one and only one presence type at any one time,
		   * representing their availability for communication. The default presence
		   * type is {@link PresenceType.UNSET}.
		   */
		g_object_interface_install_property (iface, g_param_spec_enum ("presence-type", "presence-type", "presence-type", FOLKS_TYPE_PRESENCE_TYPE, FOLKS_PRESENCE_TYPE_UNSET, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
		/**
		   * The contact's presence message.
		   *
		   * This is a short message written by the contact to add detail to their
		   * presence type ({@link Folks.PresenceOwner.presence_type}). If the contact
		   * hasn't set a message, it will be an empty string.
		   */
		g_object_interface_install_property (iface, g_param_spec_string ("presence-message", "presence-message", "presence-message", NULL, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
	}
}


/**
 * Interface exposing a {@link Persona}'s or {@link Individual}'s presence;
 * their current availability, such as for chatting.
 *
 * If the {@link Backend} providing the {@link Persona} doesn't support
 * presence, the {@link Persona}'s `presence_type` will be set to
 * {@link PresenceType.UNSET} and their `presence_message` will be an empty
 * string.
 */
GType folks_presence_owner_get_type (void) {
	static volatile gsize folks_presence_owner_type_id__volatile = 0;
	if (g_once_init_enter (&folks_presence_owner_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (FolksPresenceOwnerIface), (GBaseInitFunc) folks_presence_owner_base_init, (GBaseFinalizeFunc) NULL, (GClassInitFunc) NULL, (GClassFinalizeFunc) NULL, NULL, 0, 0, (GInstanceInitFunc) NULL, NULL };
		GType folks_presence_owner_type_id;
		folks_presence_owner_type_id = g_type_register_static (G_TYPE_INTERFACE, "FolksPresenceOwner", &g_define_type_info, 0);
		g_type_interface_add_prerequisite (folks_presence_owner_type_id, G_TYPE_OBJECT);
		g_once_init_leave (&folks_presence_owner_type_id__volatile, folks_presence_owner_type_id);
	}
	return folks_presence_owner_type_id__volatile;
}



